<?php


namespace App\Http\Controllers;


use Illuminate\Support\Facades\DB;
use App\Models\Order;
use App\Models\OrderPatient;
use App\Models\Patient;
use App\Models\User;

class AppiontController extends Controller
{
   public function getAppiontInfo()
   {
       $data = request()->all();
//       dd(strtotime('2021-01-20 09:31:00'));
       $defaulRes = [
           'server_handle_result'=>0,
           'reserve_check_result'=>0,
           'allow_get_ticket'=>0,
           'tip_msg'=>'',
           'reserve_service_no'=>'Y',
           'reserve_date'=>'',
           'reserve_start_time'=>'',
           'reserve_end_time'=>'',
           'allow_post_ticket'=>0,
       ];

       if(request()->isMethod('post')){
           $defaulRes = ['server_handle_result'=>1,'tip_msg'=>''];
           if(empty($data['orderId'])){
               $defaulRes['tip_msg'] = '请输入订单id';
               exit(json_encode($defaulRes));
           }

           if($data['reqNo']) {
               Order::where('id',$data['orderId'])->update(['is_ticket'=>1]);
               $defaulRes['tip_msg'] = 'ok';
           }
           exit(json_encode($defaulRes));

       } else {
           if(empty($data['telphone'])){
               $defaulRes['tip_msg'] = '请输入手机号';
               exit(json_encode($defaulRes));
           }
//       $sign = md5($data['id'].$data['telphone'].$data['barcode'].$data['st'].$data['st'].$data['area'].$data['st'].$data['st'].$data['SecretKey']);
//dd($sign);
           if(empty($data['sig'])){
               $defaulRes['tip_msg'] = '请输入sig签名';
               exit(json_encode($defaulRes));
           }
           if(empty($data['SecretKey']) || $data['SecretKey'] != 2018){
               $defaulRes['tip_msg'] = 'SecretKey秘钥错误';
               exit(json_encode($defaulRes));
           }

           if(empty($data['st']) ){
               $defaulRes['tip_msg'] = '请输入时间信息';
               exit(json_encode($defaulRes));
           }

           $sign = md5($data['id'].$data['telphone'].$data['barcode'].$data['st'].$data['st'].$data['area'].$data['st'].$data['st'].$data['SecretKey']);
           if($data['sig'] != $sign){
               $defaulRes['sig'] = '签名验证失败';
               exit(json_encode($defaulRes));
           }

           //先用患者表找，如果没有就直接查找用户表
           $user_id = Patient::where('phone',$data['telphone'])->value('user_id');
           if(empty($user_id)){
               $user_id = User::where('phone',$data['telphone'])->value('id');
           }

           if(empty($user_id)){
               $defaulRes['sig'] = '无效账号';
               exit(json_encode($defaulRes));
           }

           DB::enableQueryLog();
           $order = Order::where('user_id',$user_id)->select('id','order_sn','user_id','patient_id','is_ticket')->with('orderPatient:order_id,appoint_start_time,appoint_end_time');

           if($data['st']){
               $order = $order->whereHas('orderPatient',function ($query) use ($data){
                   $query->where('appoint_start_time','<=',$data['st']);
                   $query->where('appoint_end_time','>=',$data['st']);
               });
           }
           $order_list =$order->first();
           dump(DB::getQueryLog());
           if(empty($order_list)){
               $defaulRes['tip_msg'] = '无预约';
               exit(json_encode($defaulRes));
           }
           $order = $order_list->toArray();

           $defaulRes['orderId'] = $order['id'];
           $defaulRes['server_handle_result'] = 1;
           if( $order['is_ticket'] == 0 && !empty($order['order_patient'])){
               if(intval($order['order_patient']['appoint_start_time']) < intval($data['st']) || intval($data['st']) < time()){
                   $defaulRes['sig'] = '预约已过期，您预约的时间为：'.date('Y-m-d',strtotime($order['order_patient']['appoint_start_time'])).date('H:i',$order['order_patient']['appoint_start_time']).'~'.date('H:i',$order['order_patient']['appoint_end_time']);
                   exit(json_encode($defaulRes));
               }
               $defaulRes['reserve_start_time']  = date('H:i',intval($order['order_patient']['appoint_start_time']));
               $defaulRes['reserve_end_time']  = date('H:i',intval($order['order_patient']['appoint_end_time']));
               $defaulRes['allow_post_ticket']  = 1;
               $defaulRes['reserve_check_result']  = 1;
               $defaulRes['reserve_date']  = date('Y-m-d',strtotime(intval($order['order_patient']['appoint_start_time'])));
           } else {
               $defaulRes['reserve_check_result']  = 1;
               $defaulRes['allow_post_ticket']  = 0;
           }

//           foreach ($order_list as $order){
//               $defauldata = $defaulRes;
//               $defauldata['orderId'] = $order['id'];
//               if(!$order['is_ticket'] && !empty($order['orderPatient'])){
//                   $defauldata['reserve_start_time']  = $order['orderPatient']['appoint_start_time'];
//                   $defauldata['reserve_end_time']  = $order['orderPatient']['appoint_end_time'];
//                   $defauldata['allow_post_ticket']  = 1;
//                   $defauldata['reserve_check_result']  = 1;
//                   $defauldata['reserve_date']  = date('Y-m-d',strtotime($order['orderPatient']['appoint_start_time']));
//               } else {
//                   $defauldata['reserve_check_result']  = 1;
//                   $defauldata['allow_post_ticket']  = 0;
//               }
//               $appiontList [] = $defauldata;
//           }


           exit(json_encode($defaulRes));
       }

   }
}
